﻿import es
import keyvalues
import langlib
import os
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2011/language/"

messages_common = langlib.Strings(lang_dir + "messages_common.ini")
messages_text = langlib.Strings(lang_dir + "admin/manager/messages_manager_admins.ini")
popup_common = langlib.Strings(lang_dir + "popup_common.ini")
popup_text = langlib.Strings(lang_dir + "admin/manager/popup_manager_admins.ini")

kg_admins = "soccer_mod_admins"
kg_set = "sm_keygroup_set"

access = ["match", "cap", "referee", "training", "skins", "change_map", "settings", "manager"]

# ******************** Load ********************
def load():
	if os.path.isfile("cstrike/cfg/soccer_mod/es_soccer_mod_admins_db.txt") == True:
		es.keygroupload(kg_admins, "soccer_mod")

	create_popup()

	es.addons.registerSayFilter(filter)

	es.load("soccer_mod_2011/admin/manager/admins/create")

# ******************** Create popup ********************
def create_popup():
	popup = popuplib.create("sm_popup_admin_manager_admins")

	popup.addline("SOCCER MOD %s" % (popup_text("title")))
	popup.addline(" ")

	values = ["add", "add_player", "edit", "remove"]
	for i in range(0, len(values)):
		popup.addline("->%s. %s" % (i + 1, popup_text(values[i])))

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	for i in range(1, 5):
		popup.select(i, popup_choice)

	for i in range(5, 9):
		popup.submenu(i, "sm_popup_admin_manager_admins")

	popup.submenu(9, "sm_popup_admin_manager")

# ******************** Popup choice ********************
def popup_choice(userid, choice, name):
	popup_name = "sm_popup_%s" % (userid)
	if popuplib.exists(popup_name):
		popuplib.delete(popup_name)

	if choice < 2:
		set_key(userid, "manager_admin_add_name", "add_admin_name")
	else:
		if choice == 2:
			myPopup = popuplib.easymenu(popup_name, None, add)
			myPopup.settitle(messages_text("select_player"))

			for ply in playerlib.getPlayerList("#human"):
				myPopup.addoption(ply.userid, ply.name)

		elif choice == 3:
			myPopup = popuplib.easymenu(popup_name, None, edit)
			myPopup.settitle(messages_text("edit_admin"))

		elif choice == 4:
			myPopup = popuplib.easymenu(popup_name, None, remove)
			myPopup.settitle(messages_text("remove_admin"))

		if choice > 2:
			admins = keyvalues.getKeyGroup(kg_admins)
			for item in admins:
				myPopup.addoption(item, es.keygetvalue(kg_admins, item, "name"))

		myPopup.submenu(10, "sm_popup_admin_manager_admins")

		popuplib.send(popup_name, userid)

# ******************** Create popup edit ********************
def create_popup_edit(userid, steamid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)

	popup.addline("SOCCER MOD %s" % (popup_text("title_edit")))
	popup.addline(" ")
	popup.addline("->1. %s: %s" % (popup_text("name"), es.keygetvalue(kg_admins, steamid, "name")))
	popup.addline("->2. %s: %s" % (popup_text("steamid"), steamid))
	popup.addline("->3. %s" % (popup_text("access")))
	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	for i in range(1, 4):
		popup.select(i, popup_choice_edit)

	for i in range(4, 9):
		popup.submenu(i, name)

	popup.submenu(9, "sm_popup_admin_manager_admins")

	popuplib.send(name, userid)

# ******************** Popup edit choice ********************
def popup_choice_edit(userid, choice, popupid):
	if choice == 1:
		set_key(userid, "manager_admin_edit_name", "add_admin_name")

	elif choice == 2:
		set_key(userid, "manager_admin_edit_steamid", "add_admin_steamid")

	elif choice == 3:
		create_popup_edit_access(userid, es.keygetvalue(kg_set, es.getplayersteamid(userid), "edit"))

# ******************** Create popup edit access ********************
def create_popup_edit_access(userid, steamid):
	name = "sm_popup_%s" % (userid)
	if popuplib.exists(name):
		popuplib.delete(name)

	popup = popuplib.create(name)

	popup.addline("SOCCER MOD %s" % (popup_text("title_edit_access")))
	popup.addline(" ")
	popup.addline("%s:" % (es.keygetvalue(kg_admins, steamid, "name")))
	popup.addline(" ")

	for i in range(0, len(access)):
		try:
			if int(es.keygetvalue(kg_admins, steamid, access[i])) == 1:
				line = "->%s. %s: %s" % (i + 1, popup_text(access[i]), popup_text("yes"))
			else:
				line = "->%s. %s: %s" % (i + 1, popup_text(access[i]), popup_text("no"))
		except ValueError:
			line = "->%s. %s: %s" % (i + 1, popup_text(access[i]), popup_text("no"))
		popup.addline(line)

	popup.addline(" ")
	popup.addline("->9. %s" % (popup_common("back")))
	popup.addline(" ")
	popup.addline("0. %s" % (popup_common("close")))

	for i in range(1, len(access) + 1):
		popup.select(i, popup_choice_edit_access)

	popup.select(9, popup_choice_edit_access)

	popuplib.send(name, userid)

# ******************** Popup edit access choice ********************
def popup_choice_edit_access(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)
	steamid = es.keygetvalue(kg_set, player.steamid, "edit")

	if choice < 9:
		if access[choice - 1] == "manager":
			number = 0
			for admin in keyvalues.getKeyGroup(kg_admins):
				value = str(admin)
				value = value.encode("utf-8")
				if value != steamid:
					if int(admin["manager"]) == 1:
						number += 1
		else:
			number = 1

		if choice > 0 and choice < 9:
			try:
				if int(es.keygetvalue(kg_admins, steamid, access[choice - 1])) == 1:
					if number > 0:
						es.keysetvalue(kg_admins, steamid, access[choice - 1], 0)
					else:
						es.tell(userid, "#green", messages_text("1_admin", tokens, player.get("lang")))
				else:
					es.keysetvalue(kg_admins, steamid, access[choice - 1], 1)
			except ValueError:
				es.keysetvalue(kg_admins, steamid, access[choice - 1], 1)

		es.keygroupsave(kg_admins, "soccer_mod")

		create_popup_edit_access(userid, steamid)
	else:
		create_popup_edit(userid, steamid)

# ******************** Easymenu choice ********************
def add(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("userid", choice) == 1:
		target = playerlib.getPlayer(choice)
		tokens["name"] = target.name

		if es.exists("key", kg_admins, target.steamid) == 0:
			create(userid, target.name, target.steamid)
		else:
			es.tell(userid, "#green", messages_text("add_admin_exist", tokens, player.get("lang")))
			popuplib.send("sm_popup_admin_manager_admins", userid)
	else:
		es.tell(userid, "#green", messages_common("no_player_found", tokens, player.get("lang")))
		popuplib.send("sm_popup_admin_manager_admins", userid)

def edit(userid, choice, keymenuname):
	if es.exists("key", kg_admins, choice) == 1:
		steamid = es.getplayersteamid(userid)

		if es.exists("key", kg_set, steamid) == 0:
			es.keycreate(kg_set, steamid)

		es.keysetvalue(kg_set, steamid, "edit", choice)

		create_popup_edit(userid, choice)
	else:
		tokens = {}
		tokens["name"] = choice

		player = playerlib.getPlayer(userid)

		es.tell(userid, "#green", messages_text("admin_no_exist", tokens, player.get("lang")))

		popuplib.send("sm_popup_admin_manager_admins", userid)

def remove(userid, choice, keymenuname):
	tokens = {}
	player = playerlib.getPlayer(userid)

	number = 0
	for admin in keyvalues.getKeyGroup(kg_admins):
		value = str(admin)
		value = value.encode("utf-8")
		if value != str(choice).encode("utf-8"):
			if int(admin["manager"]) == 1:
				number += 1

	if number > 0:
		if es.exists("key", kg_admins, choice) == 1:
			tokens["name"] = es.keygetvalue(kg_admins, choice, "name")

			es.keydelete(kg_admins, choice)
			es.keygroupsave(kg_admins, "soccer_mod")

			es.tell(userid, "#green", messages_text("admin_removed", tokens, player.get("lang")))
		else:
			tokens["name"] = choice

			es.tell(userid, "#green", messages_text("admin_no_exist", tokens, player.get("lang")))
	else:
		es.tell(userid, "#green", messages_text("1_admin", tokens, player.get("lang")))

	popuplib.send("sm_popup_admin_manager_admins", userid)

# ******************** Say filter ********************
def filter(userid, text, teamonly):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", kg_set, player.steamid) == 1:
		type = es.keygetvalue(kg_set, player.steamid, "setting_type")
		text = text.strip('"')

		if type == "manager_admin_add_name":
			if text != "!cancel":
				es.keysetvalue(kg_set, player.steamid, "setting_type", "manager_admin_add_steamid")
				es.keysetvalue(kg_set, player.steamid, "name", text)

				es.tell(userid, "#green", messages_text("add_admin_steamid", tokens, player.get("lang")))
			else:
				clear_key(userid, player.steamid)

			return (0, None, 0)

		elif type == "manager_admin_add_steamid":
			if text != "!cancel":
				name = es.keygetvalue(kg_set, player.steamid, "name")
				tokens["name"] = name

				if es.exists("key", kg_admins, text) == 0:
					create(userid, name, text)
				else:
					es.tell(userid, "#green", messages_text("add_admin_exist", tokens, player.get("lang")))
					clear_key(userid, player.steamid)
			else:
				clear_key(userid, player.steamid)

			return (0, None, 0)

		elif type == "manager_admin_edit_name":
			steamid = es.keygetvalue(kg_set, player.steamid, "edit")

			if text != "!cancel":
				es.keysetvalue(kg_admins, steamid, "name", text)

				es.server.cmd("keygroupsort %s name asc #alpha" % (kg_admins))
				es.keygroupsave(kg_admins, "soccer_mod")

				tokens["name"] = text
				es.tell(userid, "#green", messages_text("name_changed", tokens, player.get("lang")))

			es.keydelete(kg_set, player.steamid)
			es.keycreate(kg_set, player.steamid)
			es.keysetvalue(kg_set, player.steamid, "edit", steamid)

			create_popup_edit(userid, steamid)

			return (0, None, 0)

		elif type == "manager_admin_edit_steamid":
			steamid = es.keygetvalue(kg_set, player.steamid, "edit")

			if text != "!cancel":
				tokens["steamid"] = text
				tokens["name"] = text

				if es.exists("key", kg_admins, text) == 0:
					es.keycreate(kg_admins, text)

					es.keysetvalue(kg_admins, text, "name", es.keygetvalue(kg_admins, steamid, "name"))

					for i in range(0, len(access)):
						es.keysetvalue(kg_admins, text, access[i], es.keygetvalue(kg_admins, steamid, access[i]))

					es.keydelete(kg_admins, steamid)

					es.keygroupsave(kg_admins, "soccer_mod")

					es.keysetvalue(kg_set, player.steamid, "edit", text)
					steamid = text

					es.tell(userid, "#green", messages_text("steamid_changed", tokens, player.get("lang")))
				else:
					es.tell(userid, "#green", messages_text("add_admin_exist", tokens, player.get("lang")))

			es.keydelete(kg_set, player.steamid)
			es.keycreate(kg_set, player.steamid)
			es.keysetvalue(kg_set, player.steamid, "edit", steamid)

			create_popup_edit(userid, steamid)

			return (0, None, 0)

		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def set_key(userid, type, lang):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", kg_set, player.steamid) == 0:
		es.keycreate(kg_set, player.steamid)

	es.keysetvalue(kg_set, player.steamid, "setting_type", type)

	es.tell(userid, "#green", messages_text(lang, tokens, player.get("lang")))

def create(userid, name, steamid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	es.keycreate(kg_admins, steamid)
	es.keysetvalue(kg_admins, steamid, "name", name)

	for item in access:
		es.keysetvalue(kg_admins, steamid, item, 0)

	es.server.cmd("keygroupsort %s name asc #alpha" % (kg_admins))
	es.keygroupsave(kg_admins, "soccer_mod")

	tokens["name"] = name
	es.tell(userid, "#green", messages_text("admin_added", tokens, player.get("lang")))

	es.keydelete(kg_set, player.steamid)
	es.keycreate(kg_set, player.steamid)
	es.keysetvalue(kg_set, player.steamid, "edit", steamid)

	create_popup_edit_access(userid, steamid)

def clear_key(userid, steamid):
	es.keydelete(kg_set, steamid)

	popuplib.send("sm_popup_admin_manager_admins", userid)

# ******************** Unload ********************
def unload():
	if es.exists("keygroup", kg_admins) == 1:
		es.keygroupdelete(kg_admins)

	es.addons.unregisterSayFilter(filter)

	popuplib.delete("sm_popup_admin_manager_admins")

	es.unload("soccer_mod_2011/admin/manager/admins/create")