﻿import cmdlib
import es

addon = es.import_addon("soccer_mod_2011/cfg")

# ******************** Load ********************
def load():
	es.set("sm_match_sounds_on", 1)
	es.set("sm_match_public_start_on", 0)
	es.set("sm_match_public_pause_on", 0)
	es.set("sm_match_public_unpause_on", 0)
	es.set("sm_match_public_stop_on", 0)
	es.set("sm_match_swap_names_on", 0)
	es.set("sm_match_score_board_on", 1)
	es.set("sm_match_golden_goal_on", 1)

	cmdlib.registerServerCommand("soccer_mod_match_sounds_on", sounds, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_public_start_on", public_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_public_pause_on", public_pause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_public_unpause_on", public_unpause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_public_stop_on", public_stop, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_swap_names_on", swap_names, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_score_board_on", score_board, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_golden_goal_on", golden_goal, "Server Command")

	es.set("sm_match_sound_round_start", "soccer_mod/match/kickoff.wav")
	es.set("sm_match_sound_round_end", "soccer_mod/match/wickedsick.mp3")
	es.set("sm_match_sound_period_end", "soccer_mod/match/halftime.wav")
	es.set("sm_match_sound_match_end", "soccer_mod/match/endmatch.wav")

	cmdlib.registerServerCommand("soccer_mod_match_sound_round_start", sound_round_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_round_end", sound_round_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_period_end", sound_period_end, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_sound_match_end", sound_match_end, "Server Command")

	addon.reg("sm_match_command_start", "!start", "soccer_mod_2011/modules/match/cmd_start")
	addon.reg("sm_match_command_pause", "!pause", "soccer_mod_2011/modules/match/cmd_pause")
	addon.reg("sm_match_command_unpause", "!unpause", "soccer_mod_2011/modules/match/cmd_unpause")
	addon.reg("sm_match_command_stop", "!stop", "soccer_mod_2011/modules/match/cmd_stop")

	cmdlib.registerServerCommand("soccer_mod_match_command_start", command_start, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_pause", command_pause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_unpause", command_unpause, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_match_command_stop", command_stop, "Server Command")

# ******************** Commands ********************
def sounds(args):
	addon.boolean("sm_match_sounds_on", args[0])

def public_start(args):
	addon.boolean("sm_match_public_start_on", args[0])

def public_pause(args):
	addon.boolean("sm_match_public_pause_on", args[0])

def public_unpause(args):
	addon.boolean("sm_match_public_unpause_on", args[0])

def public_stop(args):
	addon.boolean("sm_match_public_stop_on", args[0])

def swap_names(args):
	addon.boolean("sm_match_swap_names_on", args[0])

def score_board(args):
	addon.boolean("sm_match_score_board_on", args[0])

def golden_goal(args):
	addon.boolean("sm_match_golden_goal_on", args[0])

def sound_round_start(args):
	es.set("sm_match_sound_round_start", args[0])

def sound_round_end(args):
	es.set("sm_match_sound_round_end", args[0])

def sound_period_end(args):
	es.set("sm_match_sound_period_end", args[0])

def sound_match_end(args):
	es.set("sm_match_sound_match_end", args[0])

def command_start(args):
	addon.unreg("sm_match_command_start")
	addon.reg("sm_match_command_start", args[0], "soccer_mod_2011/modules/match/cmd_start")

def command_pause(args):
	addon.unreg("sm_match_command_pause")
	addon.reg("sm_match_command_pause", args[0], "soccer_mod_2011/modules/match/cmd_pause")

def command_unpause(args):
	addon.unreg("sm_match_command_unpause")
	addon.reg("sm_match_command_unpause", args[0], "soccer_mod_2011/modules/match/cmd_unpause")

def command_stop(args):
	addon.unreg("sm_match_command_stop")
	addon.reg("sm_match_command_stop", args[0], "soccer_mod_2011/modules/match/cmd_stop")

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_match_sounds_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_public_start_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_public_pause_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_public_unpause_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_public_stop_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_swap_names_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_score_board_on")
	cmdlib.unregisterServerCommand("soccer_mod_match_golden_goal_on")

	cmdlib.unregisterServerCommand("soccer_mod_match_sound_round_start")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_round_end")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_period_end")
	cmdlib.unregisterServerCommand("soccer_mod_match_sound_match_end")

	cmdlib.unregisterServerCommand("soccer_mod_match_command_start")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_pause")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_unpause")
	cmdlib.unregisterServerCommand("soccer_mod_match_command_stop")

	addon.unreg("sm_match_command_start")
	addon.unreg("sm_match_command_pause")
	addon.unreg("sm_match_command_unpause")
	addon.unreg("sm_match_command_stop")